import { Injectable } from '@angular/core';
import { Router, CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';

import { AccountService } from '../services';

@Injectable({providedIn: 'root'})
export class AuthGuard implements CanActivate{
  constructor(
    private router: Router,
    private accountService: AccountService
  ){}

  canActivate(route:ActivatedRouteSnapshot, state: RouterStateSnapshot){
    const user = this.accountService.userValue;
    if(user){
      return true;
    }
    this.router.navigate(['account/login'],{queryParams:{returnUrl: state.url} });
    return false;
  }
};
